#!/usr/bin/env python3
#-*- coding:utf-8-*-
"""
4、工资计算
    某公司内有多名员工，技术部门为减少财务部门每月计算工资的工作量，决定帮助他们写一个程序，以自动化的方式每月计算员工的工资。
    具体需求如下：
    (1)、员工类，员工拥有基本属性
        员工编号   整数
        姓名       字符串
        基本信息   字符串
        岗位与工资  list[dict]  # list中的基本类型是字典，考虑到有员工可能身兼数职，此时计算工资的计算是累加的
                                # 比如员工A，程序员与扫地两项工作，每项工作的工资不同，结算工资时，需要两项加在一起
                                # 注意，这里的工资是按照周为单位来进行计算的，也就是说基本的数据结构应该是 [{"程序员",2000},{"扫地",1000}]
        工资计算开始时间  字符串
        工资计算结束时间  字符串

    (2)、财务类
    具体要求：
        (1)、其中包含计算员工工资的方法，输入是员工类的实例。
        (2)、要以员工的工作时长来计算工资，可以简单点用总工作时长除以7，就是固定周数，不足一周不算工资
        (3)、以下表格为输出样式要求，将讲计算结果信息写入同一个excel表格中，excel名称为"员工工资计算"
    输出表格基本样式
    |员工编号| 工资结算时间|    员工姓名   |    员工基本信息   |  岗位   |  工资   |   说明       | 工资总计
    |     1 |  2019-1  |     小A       |    居住在回龙观   |  程序员 |  8000   | 工资结算4周  |
    |     1 |  2019-1  |     小A       |    居住在回龙观   |  扫地   |  4000   | 工资结算4周  | 12000
    |     2 |  2019-1  |     小B       |    居住在天通苑   |  程序员 |  8000   | 工资结算4周  | 8000
    |     3 |  2019-1  |     小C       |    居住在西二旗   |  程序员 |  8000   | 工资结算4周  | 8000
    |     4 |  2019-1  |     小D       |    居住在望京南   |  程序员 |  8000   | 工资结算4周  | 8000

    (3)、跑通以上表格中的数据才算作业通过，自己要进行测试。
         注意，后边一个员工调用工资方法时，不能覆盖上一个员工的信息，要追加写入,如果是同一个员工，写入第二条信息时的工资总计字段时要把第一条的清除掉

    (4)、每进行一个员工的信息计算时，要求计算过程输入到日志cala_salary.log中，如果有错误发生，则打印到日志中错误信息。日志可自由配置合法选项即可(读取配置文件)

    (5)、测试用例demo:
    worker=worker()
    worker.work_id=1
    worker.name="小A"
    worker.info="住在回龙观"
    worker.work_and_salary_list = [{"程序员",2000},{"扫地",1000}]
    worker.start_time="2019-01-01"
    worker.end_time="2019-01-31"

    Finace.calc_salary(worker)

    worker=worker()
    worker.name="小B"
    worker.info="住在回龙观"
    worker.work_and_salary_list = [{"程序员",2000},{"扫地",1000}]
    worker.start_time="2019-01-01"
    worker.end_time="2019-01-31"
    Finace.calc_salary(worker)
"""
import xlwt
import xlrd
import os
import datetime
import re
from homework.log.cala_salary_log import TNLog
from xlutils.copy import copy

class Excel:
    def __init__(self):
        pass
    def work_basic_info_sheet(self,file_dir,sheet_name,value_title):
        path = os.path.exists(file_dir)
        if path == False :
             return Excel.work_write_excel_xls(self,file_dir, sheet_name, value_title)

    def work_write_excel_xls(self,file_dir, sheet_name,value):
        index = len(value)  # 获取需要写入数据的行数
        workbook = xlwt.Workbook()  # 新建一个工作簿
        sheet = workbook.add_sheet(sheet_name)  # 在工作簿中新建一个表格
        for i in range(0, index):
            for j in range(0, len(value[i])):
                sheet.write(i, j, value[i][j])  # 像表格中写入数据（对应的行和列）
        workbook.save(file_dir)  # 保存工作簿
        print("xls格式表格创建成功！")
        return True

    def write_excel_xls_append(self,path, value):
        index = len(value)  # 获取需要写入数据的行数
        workbook = xlrd.open_workbook(path)  # 打开工作簿
        sheets = workbook.sheet_names()  # 获取工作簿中的所有表格
        worksheet = workbook.sheet_by_name(sheets[0])  # 获取工作簿中所有表格中的的第一个表格
        rows_old = worksheet.nrows  # 获取表格中已存在的数据的行数
        new_workbook = copy(workbook)  # 将xlrd对象拷贝转化为xlwt对象
        new_worksheet = new_workbook.get_sheet(0)  # 获取转化后工作簿中的第一个表格
        for i in range(0, index):
            for j in range(0, len(value[i])):
                new_worksheet.write(i + rows_old, j, value[i][j])  # 追加写入数据，注意是从i+rows_old行开始写入
        new_workbook.save(path)  # 保存工作簿
        print("xls格式表格【追加】写入数据成功！")
        return True
class  Finace(object):
    def __init__(self,worker):
        self.worker = worker

    def calc_salary(self):
        date_end = datetime.datetime.strptime(worker.end_time, '%Y-%m-%d')
        date_start = datetime.datetime.strptime(worker.start_time, '%Y-%m-%d')
        salary_date = worker.end_time[:7]
        diff = ((date_end - date_start) / 7).days
        sum_salary = 0
        r = []
        l = len(worker.work_and_salary_list)
        for k,salary_job in enumerate(worker.work_and_salary_list):
            salary = re.findall ('[0-9.]+',str(salary_job))[0]#工资
            pat = re.compile(r'[\u4e00-\u9fa5]+')
            jobs = pat.findall(str(salary_job))#工作
            intrs = '工资结算%d周' % (diff)
            if l > 1:
               if k==0:
                   v = [[worker.work_id, salary_date, worker.name, worker.info, jobs, salary, intrs, '']]
                   sum_salary += float(salary)
               else:
                    sum_salary += float(salary)
                    v = [[worker.work_id, salary_date, worker.name, worker.info, jobs, salary, intrs, sum_salary]]
            else:
               sum_salary += float(salary)
               v = [[worker.work_id, salary_date, worker.name, worker.info, jobs, salary, intrs, sum_salary]]
            r = r + v
        return r
class Worker:
    def __init__(self):
        pass

if __name__ == "__main__":
    try:
        logger = TNLog()
        ex = Excel()
        work_xls = "xls格式员工工资信息表.xls"
        book_name_xls = 'xls格式员工工资簿.xls'
        value_title = [["员工编号", "工资结算时间", "员工姓名", "员工基本信息", "岗位", "工资", "说明", "工资总计"], ]
        #建立员工基本信息表
        basc_info = ex.work_basic_info_sheet(work_xls,book_name_xls, value_title)

        worker = Worker()
        worker.work_id = 1
        worker.name = "小A"
        worker.info = "住在回龙观"
        worker.work_and_salary_list = [{"扫地d",2000.5},{"出纳",1000}]
        worker.start_time = "2019-01-01"
        worker.end_time = "2019-01-31"

        # worker = Worker()
        # worker.work_id = 2
        # worker.name = "小B"
        # worker.info = "住在泰国"
        # worker.work_and_salary_list = [{"会计", 2000},{"扫地",1000}]
        # worker.start_time = "2019-01-01"
        # worker.end_time = "2019-01-31"

        finace = Finace(worker)
        rs = finace.calc_salary()
        # 计算员工工资追加到员工工资表中
        ex.write_excel_xls_append(work_xls, rs)
        logger.info(rs)
    except Exception as e:
        logger.error(e)

